package de.thpeetz.kontor.tysc.views;

import com.vaadin.flow.component.ComponentEvent;
import com.vaadin.flow.component.ComponentEventListener;
import com.vaadin.flow.component.Key;
import com.vaadin.flow.component.button.Button;
import com.vaadin.flow.component.button.ButtonVariant;
import com.vaadin.flow.component.formlayout.FormLayout;
import com.vaadin.flow.component.orderedlayout.HorizontalLayout;
import com.vaadin.flow.component.textfield.TextField;
import com.vaadin.flow.data.binder.BeanValidationBinder;
import com.vaadin.flow.data.binder.Binder;

import de.thpeetz.kontor.tysc.data.Sport;
import lombok.extern.slf4j.Slf4j;

@Slf4j
public class SportForm extends FormLayout {

    TextField name = new TextField("Name");

    Button save = new Button("Save");
    Button delete = new Button("Delete");
    Button close = new Button("Cancel");

    Binder<Sport> binder = new BeanValidationBinder<>(Sport.class);

    public SportForm() {
        addClassName("sport-form");
        binder.bindInstanceFields(this);

        add(name, createButtonsLayout());
    }

    private HorizontalLayout createButtonsLayout() {
        save.addThemeVariants(ButtonVariant.LUMO_PRIMARY);
        delete.addThemeVariants(ButtonVariant.LUMO_ERROR);
        close.addThemeVariants(ButtonVariant.LUMO_TERTIARY);

        save.addClickShortcut(Key.ENTER);
        close.addClickShortcut(Key.ESCAPE);

        save.addClickListener(event -> validateAndSave());
        delete.addClickListener(event -> fireEvent(new DeleteEvent(this, binder.getBean())));
        close.addClickListener(event -> fireEvent(new CloseEvent(this)));

        binder.addStatusChangeListener(e -> save.setEnabled(binder.isValid()));
        return new HorizontalLayout(save, delete, close);
    }

    private void validateAndSave() {
        if (binder.isValid()) {
            fireEvent(new SaveEvent(this, binder.getBean()));
        }
    }

    public void setSport(Sport sport) {
        binder.setBean(sport);
    }

    public abstract static class SportFormEvent extends ComponentEvent<SportForm> {
        private Sport sport;

        protected SportFormEvent(SportForm source, Sport sport) {
            super(source, false);
            this.sport = sport;
        }

        public Sport getSport() {
            return sport;
        }
    }

    public static class SaveEvent extends SportFormEvent {
        SaveEvent(SportForm source, Sport sport) {
            super(source, sport);
        }
    }

    public static class DeleteEvent extends SportFormEvent {
        DeleteEvent(SportForm source, Sport sport) {
            super(source, sport);
        }
    }

    public static class CloseEvent extends SportFormEvent {
        CloseEvent(SportForm source) {
            super(source, null);
        }
    }

    public void addDeleteListener(ComponentEventListener<DeleteEvent> listener) {
        addListener(DeleteEvent.class, listener);
    }

    public void addSaveListener(ComponentEventListener<SaveEvent> listener) {
        addListener(SaveEvent.class, listener);
    }

    public void addCloseListener(ComponentEventListener<CloseEvent> listener) {
        addListener(CloseEvent.class, listener);
    }
}
